<template>
  <component :is="component" v-model="text" v-bind="$attrs" />
</template>
<script>
import { DCCXMLElement } from "@d-ptb/dcc-js";
import debounce from "lodash/debounce";
import { isArray } from "lodash";

export default {
  name: "DccArrayWrapper",
  props: {
    value: Array,
    separator: {
      type: String,
      default: ", ",
    },
    component: Object,
  },
  computed: {
    text: {
      get() {
        if (!this.value || !isArray(this.value)) return null;
        return new DCCXMLElement({
          _text: this.value.map((x) => x._text).join(this.separator),
        });
      },
      set: debounce(function (value) {
        if (value) {
          this.$emit(
            "input",
            value._text
              .split(this.separator)
              .map((x) => new DCCXMLElement({ _text: x }))
          );
        } else {
          this.$emit("input", value);
        }
      }, 500),
    },
  },
};
</script>
